#include "CBasicDebugger.inc"
#include "CBreakPointCollection.inc"

#ifndef __CAdvancedDebugger_defined__
#define __CAdvancedDebugger_defined__

// flags for breakpoints
#define BREAKPOINT_START 1
#define BREAKPOINT_STOP  2


class CAdvancedDebugger : CBasicDebugger
{
	// hidding debugger
	declare virtual HideDebuggerOnTeb(),BOOL;
	declare virtual HideDebuggerOnTebNow(),BOOL;

	// disabling functions
	declare virtual HideApi(string *szModule, string *szApiName, int NumberOfArgs, int ReturnValue),BOOL;
	declare virtual PathModule(void *PathAddr, int NumberOfArgs, int ReturnValue),BOOL;
	declare virtual GetProcessApiPointer(string *szModule, string *szApiName, void *lpBaseOfDll, void *ppPointer),BOOL;
	// instalation if hooks
	declare virtual InstallFunctionHook(string *szModule, string *szApiName, string *format, opt void *ModuleBase),BOOL;
//	declare virtual SetReturnValue(DWORD dwReturnValue);
//	declare virtual OnEnterHookedFunction(void *address, void *ReturnAddress, void *Arguments, CONTEXT *ctx);
//	declare virtual OnLeaveHookedFunction();
	declare virtual GetFunctionArguments(void *BreakpointAddress, CONTEXT ctx/*,BOOL AppendReturnValue,opt DWORD ReturnValue*/),heap;
	CBreakPointCollection m_breakpoints;
}

#endif

