%include "list.inc"

global _ListEnumFromEnd@12
extern _ListGetLast@8
extern _ListGetPrev@8

_ListEnumFromEnd@12: ; ListEnumFromEnd(llist *root, void *lpPos, void *lpdata),int
	push esi
	push edi
	%define root esi   ; 12
	%define lpPos edi  ; 16
	%define lpdata edx ; 20  

	mov  root,  [esp+12]

	push root
	call _ListValidate@4           ; if (root is valid) ...
	jz  .quit

	mov  lpPos, [esp+16]
	mov  lpdata,[esp+20]

	mov  eax,[lpPos]     ; if (*(pointer)lpPos=null)
	and  eax,eax
	jnz .else

	push lpdata
	push root
	call _ListGetLast@8   ; eax = ListGetLast(root, lpdata);
	jmp .endif
.else
	push lpdata
	push dword[lpPos]
	call _ListGetPrev@8    ; eax = ListGetPrev(*(pointer)lpPos, lpdata);
.endif
	mov [lpPos],eax     ; *(pointer)lpPos = eax
.quit
	pop  edi
	pop  esi
	ret  12

