%include "list.inc"

global _ListEnumFromStart@12
extern _ListGetFirst@8
extern _ListGetNext@8

_ListEnumFromStart@12: ; ListEnumFromStart(llist *root, void *lpPos, void *lpdata),int
	push esi
	push edi
	%define root esi   ; 12
	%define lpPos edi  ; 16
	%define lpdata edx ; 20  

	mov  root,  [esp+12]

	push root
	call _ListValidate@4           ; if (root is valid) ...
	jz  .quit

	mov  lpPos, [esp+16]
	mov  lpdata,[esp+20]

	mov  eax,[lpPos]     ; if (*(pointer)lpPos=null)
	and  eax,eax
	jnz .else

	push lpdata
	push root
	call _ListGetFirst@8   ; eax = ListGetFirst(root, lpdata);
	jmp .endif
.else
	push lpdata
	push dword[lpPos]
	call _ListGetNext@8    ; eax = ListGetNext(*(pointer)lpPos, lpdata);
.endif
	mov [lpPos],eax     ; *(pointer)lpPos = eax
.quit
	pop  edi
	pop  esi
	ret  12

