%include "list.inc"

global _ListGetFirst@8

_ListGetFirst@8: ; ListGetFirst(llist *node, void *lpdata),pointer
	push esi
	push edi
	%define root esi
	%define lpdata edi

	mov  root,[esp+12]
	mov  lpdata,[esp+16]
	push root
	call _ListValidate@4           ; if (root is valid) ...
	jz  .reteax

	; go to first node if root is not first
.goback
	mov  eax,[root+llist.prev]
	and  eax,eax
	jz  .isroot
	mov  root,eax
	jmp .goback
.isroot

	mov  eax,[root+llist.data]  ; root->data

	and  lpdata,lpdata          ; if (lpdata<>null) ...
	jz  .retroot
	mov  [lpdata],eax           ; ... *(pointer)lpdata = root->data;

.retroot
	mov  eax,root               ; return root
.reteax
	pop  edi
	pop  esi
	ret  8

