;%define debug
%include "asm.inc"
%include "list.inc"

global _ListAddHead@8

_ListAddHead@8: ; ListAddHead(llist *root , void *data),pointer
	push esi
	push edi
	push ebp
	%define root   esi
	%define new    edi
	%define second ebp
	%define data   ecx
	mov  root,[esp+16]

	call _ListValidate@4,root      ; if (root is valid) ...
	jz  .quit

;	DebugInt data,root
;	xor  eax,eax

	newlist  ; WARNING api call!
	mov  new,eax                ; llist *new = new(llist, 1);
	mov  data,[esp+20]
	mov  second,[root+llist.next]
	mov  eax,[root+llist.data]  ; new.data = root.data;
	mov  [new+llist.data],eax
	mov  [root+llist.data],data ; root.data = data
	mov  eax,[root+llist.next]  ; new.next = root.next
	mov  [new+llist.next],eax
	mov  [new+llist.prev],root  ; new.prev = root
	mov  [root+llist.next],new  ; root.next = new
	xor  eax,eax
	mov [root+llist.prev],eax   ; root.prev = null

	and  second,second
	jz  .quit
	mov  [second+llist.prev],new

.quit
	mov eax,data                ; return data
	pop ebp
	pop edi
	pop esi
	ret 8

