%include "list.inc"

global _ListGetNext@8

_ListGetNext@8: ; ListGetNext(llist *node, opt void *lpdata),pointer
	push esi
	push edi
	%define node esi
	%define lpdata edi

	mov  node,[esp+12]          ; node
	mov  lpdata,[esp+16]        ; lpdata
	push node
	call _ListValidate@4           ; if (node is valid) ...
	jz  .reteax
	mov  node,[node+llist.next] ; ... node = node->next;

	and  node,node              ; if (node<>null)
	jz  .retnode

	and  lpdata,lpdata          ; if (lpdata<>null) ...
	jz  .retnode
	mov  eax,[node+llist.data]  ; ... *(pointer)lpdata = node->data;
	mov  [lpdata],eax

.retnode
	mov  eax,node               ; return node
.reteax
	pop  edi
	pop  esi
	ret  8

