;%define debug
%include "asm.inc"
%include "list.inc"

global _ListInsert@8
extern _ListAddHead@8
extern _ListValidate@4

_ListInsert@8: ; data ListInsert(pointer node, void *data);

	push  esi
	push  edi
	push  ebp
	%define node  esi   ; [esp+16]
	%define new   ebp
	%define next node
	%define prev  edi
	mov  node, [esp+16]
	call _ListValidate@4,node
	jz  .quit

	; previous present? if not: ListAddHead
	mov  prev,[node+llist.prev]
	and  prev,prev
	jnz  .isprev
	call _ListAddHead@8, node, [esp+20]
	jmp .quit
.isprev

	newlist
	mov  new,eax
	mov  edx,[esp+20]
	mov  [new+llist.data],edx  ; update new
	mov  [new+llist.prev],prev ; update new
	mov  [prev+llist.next],new ; update prev
	mov  [new+llist.next],next ; update new
	mov  [next+llist.prev],new ; update next






.quit
	pop  ebp
	pop  edi
	pop  esi
	mov  eax,[esp+8]
	ret  8
