%include "list.inc"

global _ListRemoveAll@8

_ListRemoveAll@8: ; ListRemoveAll(llist *root, opt int bDelete=0)
	push esi
	%define root esi   ; 12

	mov  root, [esp+8]
	push root
	call _ListValidate@4           ; if (root is valid) ...
	jz  .quit

	; go to first node if root is not first
.goback
	mov  eax,[root+llist.prev]
	and  eax,eax
	jz  .while
	mov  root,eax
	jmp .goback


.while                   ; while (root<>null)
	and  root,root
	jz  .quit

	cmp  dword[esp+12],0 ; if (bDeleteData)
	jz  .nodel
	mov  eax,[root+llist.data]
	and  eax,eax         ; and (root->data<>null)
	jz  .nodel
	delete eax           ; delete root->data;
 .nodel
	push root
	mov  root,[root+llist.next]
	delete
	jmp .while

.quit
	pop  esi
	ret  8

